float4x4 World;
float4x4 View;
float4x4 Projection;

float ka = 1;
float kd = 0.5;
float ks = 1;
float SpecularPower = 4;

//   
float4 Color = float4(1, 0, 0, 1);


float4 AmbientColor0 = float4(0.1, 0.1, 0.1, 1);
float4 DiffuseColor0 = float4(1,1,1,1);
float4 SpecularColor0 = float4(1,1,1,1);

float4 AmbientColor1 = float4(0.1, 0.1, 0.1, 1);
float4 DiffuseColor1 = float4(1,1,1,1);
float4 SpecularColor1 = float4(1,1,1,1);

float4 AmbientColor2 = float4(0.1, 0.1, 0.1, 1);
float4 DiffuseColor2 = float4(1,1,1,1);
float4 SpecularColor2 = float4(1,1,1,1);

// ,        
float3 LightPosition0 = float3(0,0,2);
float3 LightPosition1 = float3(2,0,0);
float3 LightPosition2 = float3(-2,0,0);

float3 Eye;

// TODO: add effect parameters here.

struct VertexShaderInputPhong
{
    float4 Position : POSITION0;
    float3 Normal : NORMAL;

    // TODO: add input channels such as texture
    // coordinates and vertex colors here.
};

struct VertexShaderOutputPhong
{
    float4 Position : POSITION0;
    float3 WorldPosition : TEXCOORD0;
    float3 Normal : TEXCOORD1;

    // TODO: add vertex shader outputs such as colors and texture
    // coordinates here. These values will automatically be interpolated
    // over the triangle, and provided as input to your pixel shader.
};

VertexShaderOutputPhong VertexShaderFunctionPhong(VertexShaderInputPhong input)
{
    VertexShaderOutputPhong output;

    float4 worldPosition = mul(input.Position, World);
    float4 viewPosition = mul(worldPosition, View);
    float3 worldNormal = normalize(mul(input.Normal, World));
    output.Position = mul(viewPosition, Projection);
    output.WorldPosition = worldPosition;
    output.Normal = worldNormal;
    
    // TODO: add your vertex shader code here.

    return output;
}


float4 PointLight(float3 LightPosition, float3 worldPosition, float3 worldNormal, float4 AmbientColor, float4 DiffuseColor, float4 SpecularColor)
{
    float4 Ambient = ka * AmbientColor;
    
    float3 lightDirection = normalize(LightPosition - worldPosition);
    float4 Diffuse = kd * max(0, dot(worldNormal, lightDirection)) * DiffuseColor;
    
    float3 eyeDirection = normalize(Eye - worldPosition);
    float3 reflectedLight = normalize(reflect(-lightDirection, worldNormal));
    float4 Specular = ks * pow(max(0, dot(eyeDirection, reflectedLight)), SpecularPower) * SpecularColor;

	//      1/d^2
    return (Ambient + Diffuse + Specular) / pow(length(worldPosition-LightPosition), 2);

}

float4 PixelShaderFunctionPhong(VertexShaderOutputPhong input) : COLOR0
{
    // TODO: add your pixel shader code here.
    float3 worldPosition = input.WorldPosition;
    float3 worldNormal = normalize(input.Normal);
    
    float4 light0 = PointLight(LightPosition0, worldPosition, worldNormal, AmbientColor0, DiffuseColor0, SpecularColor0);
    float4 light1 = PointLight(LightPosition1, worldPosition, worldNormal, AmbientColor1, DiffuseColor1, SpecularColor1);
    float4 light2 = PointLight(LightPosition2, worldPosition, worldNormal, AmbientColor2, DiffuseColor2, SpecularColor2);
    
    return Color * (light0 + light1 + light2);
}

technique Phong
{
    pass Pass1
    {
        // TODO: set renderstates here.

        VertexShader = compile vs_1_1 VertexShaderFunctionPhong();
        PixelShader = compile ps_3_0 PixelShaderFunctionPhong();
    }
}